using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace SS_232C_RLSW
{
    using SYSTEMSACOM;
    public partial class main : Form
    {
        //--------------------------------------------------------------------------------
        //[API`]
        //--------------------------------------------------------------------------------
        [DllImport("KERNEL32.DLL")]
        private static extern int GetPrivateProfileString(string lpAppName, string lpKeyName, string lpDefault, StringBuilder lpReturnedString, int nSize, string lpFileName);
        [DllImport("KERNEL32.DLL")]
        public static extern int WritePrivateProfileString(string lpAppName, string lpKeyName, string lpString, string lpFileName);
        //--------------------------------------------------------------------------------
        //[萔`]
        //--------------------------------------------------------------------------------
        private const string INI_FILE = @".\SS_232C_RLSW_sample.ini";           //ݒt@C
        private const string DEFAULT_COM = "COM1";                              //COM1
        private const byte DEFAULT_ID = 0xFF;                                   //ff
        private const uint DEFAULT_BAUDRATE = 9600;                             //9600bps
        private const byte DEFAULT_BYTE_SIZE = 8;                               //8bit
        private const byte DEFAULT_PARITY = (byte)SS232CRLSW.PARITY.None;       //peB
        private const byte DEFAULT_STOPBIT = (byte)SS232CRLSW.STOPBIT.Bit1;     //1bit
        //--------------------------------------------------------------------------------
        //[GA`]
        //--------------------------------------------------------------------------------
        private bool _isConnect = false;                                //ڑԋLp
        private short _output = 0;                                      //ݏoIO
        private string _com = DEFAULT_COM;                              //COM|[g                                      
        private byte _id = DEFAULT_ID;                                  //R}hID
        private uint _baudrate = DEFAULT_BAUDRATE;                      //{[[g
        private byte _byte_size = DEFAULT_BYTE_SIZE;                    //oCg
        private byte _parity = DEFAULT_PARITY;                          //peB
        private byte _stop_bit = DEFAULT_STOPBIT;                       //Xgbvrbg
        //--------------------------------------------------------------------------------
        //[constractor]
        //--------------------------------------------------------------------------------
        public main()
        {
            InitializeComponent();
        }
        //--------------------------------------------------------------------------------
        //[Evnt]tH[[h
        //[] ݒt@Cp[^ǂݍ݊eRg[ɐݒ肵܂B
        //       ǂݍݎs̎͋Klݒ肵܂B
        //--------------------------------------------------------------------------------
        private void main_Load(object sender, EventArgs e)
        {
            vfnReadIniFile();       //ݒt@C̓ǂݍ
            vfnValueToControl();    //p[^Rg[ɔf
            _isConnect = false;     //ؒf
            vfnControlsLock(false); //ؒfԂ̃Rg[ݒ
        }
        //--------------------------------------------------------------------------------
        //[Evnt]tH[A[h
        //[] ڑς݂Ȃؒfs
        //--------------------------------------------------------------------------------
        private void main_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (_isConnect)
            {
                SS232CRLSW.SS232CRLSW_close();
            }
        }
        //--------------------------------------------------------------------------------
        //[Evnt]ڑ/ؒf{^
        //[]COM|[g̐ڑ/ؒfs܂B
        //      ڑAݒݒt@CɋL܂B
        //      ڑAo͏ԂeCh̃{^ɕ\܂B
        //--------------------------------------------------------------------------------
        private void btnOpenClose_Click(object sender, EventArgs e)
        {
            int iRet;
            btnOpenClose.Enabled = false;
            if (btnOpenClose.Text == "Open")
            {
                if (bfnCheckControl())
                {
                    vfnControlToValue();                    //p[^XV
                    vfnValueToControl();                    //Rg[ɔf
                    if ((iRet = SS232CRLSW.SS232CRLSW_open(_com, _baudrate, _byte_size, _parity, _stop_bit)) != SS232CRLSW.RET_OK)
                    {
                        vfnDllError("SS232CRLSW_open", iRet);
                    }
                    else
                    {
                        vfnWriteIniFile();                  //p[^ۑ
                        btnOpenClose.Text = "Close";        //Close{^ɕύX
                        vfnControlsLock(true);              //Rg[gpύX
                        vfnReadOutput();                    //eCh̃Xe[^X\ɏo͏Ԃ\
                        vfnReadDeviceInfo();                //foCX\
                        _isConnect = true;                  //ڑς
                    }
                }
            }
            else
            {
                SS232CRLSW.SS232CRLSW_close();              //ؒf
                btnOpenClose.Text = "Open";                 //Open{^ɕύX
                vfnControlsLock(false);                     //Rg[̎gpύX
                _isConnect = false;                         //ؒfς
            }
            btnOpenClose.Enabled = true;
        }
        //--------------------------------------------------------------------------------
        //[Evnt]Ch.Set/Reset{^
        //[]eChɏo͐ݒ(ON/OFF)s܂B
        //      ݒo͏ԂQƂ܂B
        //--------------------------------------------------------------------------------
        private void btnChx_Click(object sender, EventArgs e)
        {
            short sOut;
            int iRet;
            Button btn = (Button)sender;
            int iIndex = int.Parse((string)btn.Tag);

            sOut = (short)(_output ^ (1 << iIndex));

            iRet = SS232CRLSW.SS232CRLSW_output_data(_id, sOut);
            if (iRet == SS232CRLSW.RET_OK)
            {
                vfnReadOutput();  //o͎Q
            }
            else
            {
                vfnDllError("SS232CRLSW_output_data", iRet);
            }
        }
        //--------------------------------------------------------------------------------
        //[Evnt]WI{^(7l)
        //[]ږɃIvVrݒs܂B
        //--------------------------------------------------------------------------------
        private void rdoBits8_Click(object sender, EventArgs e)
        {
            rdoBits8.Checked = true;
            rdoBits7.Checked = false;
            _byte_size = 8;
        }
        private void rdoBits7_Click(object sender, EventArgs e)
        {
            rdoBits8.Checked = false;
            rdoBits7.Checked = true;
            _byte_size = 7;
        }
        private void rdoParityNone_Click(object sender, EventArgs e)
        {
            rdoParityNone.Checked = true;
            rdoParityOdd.Checked = false;
            rdoParityEven.Checked = false;
            _parity = (byte)SS232CRLSW.PARITY.None;
        }
        private void rdoParityOdd_Click(object sender, EventArgs e)
        {
            rdoParityNone.Checked = false;
            rdoParityOdd.Checked = true;
            rdoParityEven.Checked = false;
            _parity = (byte)SS232CRLSW.PARITY.Odd;
        }
        private void rdoParityEven_Click(object sender, EventArgs e)
        {
            rdoParityNone.Checked = false;
            rdoParityOdd.Checked = false;
            rdoParityEven.Checked = true;
            _parity = (byte)SS232CRLSW.PARITY.Even;
        }
        private void rdoStop1_Click(object sender, EventArgs e)
        {
            rdoStop1.Checked = true;
            rdoStop2.Checked = false;
            _stop_bit = (byte)SS232CRLSW.STOPBIT.Bit1;
        }
        private void rdoStop2_Click(object sender, EventArgs e)
        {
            rdoStop1.Checked = false;
            rdoStop2.Checked = true;
            _stop_bit = (byte)SS232CRLSW.STOPBIT.Bit2;
        }
        //--------------------------------------------------------------------------------
        //[֐]Rg[̏Ԑݒ
        //[](ڑ^ؒf)ɍ킹ĎgpoRg[ݒ肵܂B
        //[]connect  true:ڑԁAfalse:ؒf
        //[ߒl]Ȃ
        //--------------------------------------------------------------------------------
        private void vfnControlsLock(bool connect)
        {
            //ڑgp\
            btnCh1.Enabled = connect;
            btnCh2.Enabled = connect;
            btnCh3.Enabled = connect;
            btnCh4.Enabled = connect;
            btnCh5.Enabled = connect;
            btnCh6.Enabled = connect;
            btnCh7.Enabled = connect;
            btnCh8.Enabled = connect;
            lblCh1.Enabled = connect;
            lblCh2.Enabled = connect;
            lblCh3.Enabled = connect;
            lblCh4.Enabled = connect;
            lblCh5.Enabled = connect;
            lblCh6.Enabled = connect;
            lblCh7.Enabled = connect;
            lblCh8.Enabled = connect;
            btnCh1.Text = "";
            btnCh2.Text = "";
            btnCh3.Text = "";
            btnCh4.Text = "";
            btnCh5.Text = "";
            btnCh6.Text = "";
            btnCh7.Text = "";
            btnCh8.Text = "";
            //ؒfgp\
            grpDevice.Enabled = !connect;
            grpSetting.Enabled = !connect;
        }
        //--------------------------------------------------------------------------------
        //[֐]foCX̓ǂݍ
        //[]jbgIDƃo[WbZ[W\܂B
        //[]Ȃ
        //[ߒl]Ȃ
        //--------------------------------------------------------------------------------
        private void vfnReadDeviceInfo()
        {
            byte id = 0;
            StringBuilder version = new StringBuilder(0);
            int iRet;

            iRet = SS232CRLSW.SS232CRLSW_unit_number(ref id);
            if (iRet != SS232CRLSW.RET_OK)
            {
                vfnDllError("SS232CRLSW_unit_number", iRet);
                return;
            }
            iRet = SS232CRLSW.SS232CRLSW_get_version_number(_id, version, 0);
            if (iRet < 0)
            {
                vfnDllError("SS232CRLSW_get_version_number", iRet);
                return;
            }
            version = new StringBuilder(iRet);
            iRet = SS232CRLSW.SS232CRLSW_get_version_number(_id, version, iRet);
            if (iRet < 0)
            {
                vfnDllError("SS232CRLSW_get_version_number", iRet);
                return;
            }
            MessageBox.Show(string.Format("jbgԍ:[{0:X2}]\r\n{1}", id, version.ToString()), "foCX");
        }
        //--------------------------------------------------------------------------------
        //[֐]o͏Ԃ̓ǂݍ
        //[]o͏ԂQƂAeCh̃Xe[^X\ɕ\܂B
        //[]Ȃ
        //[ߒl]Ȃ
        //--------------------------------------------------------------------------------
        private void vfnReadOutput()
        {
            short sOut = 0;
            int iRet;
            short sPtn;

            iRet = SS232CRLSW.SS232CRLSW_read_output_data(_id, ref sOut); //o͏ԎQ
            if (iRet == SS232CRLSW.RET_OK)
            {
                _output = sOut;                                   //o͏ԋL
                //eChXe[^X\ɕ\
                sPtn = 0x0001;
                btnCh1.Text = ((_output & sPtn) != 0) ? "" : "";
                sPtn = 0x0002;
                btnCh2.Text = ((_output & sPtn) != 0) ? "" : "";
                sPtn = 0x0004;
                btnCh3.Text = ((_output & sPtn) != 0) ? "" : "";
                sPtn = 0x0008;
                btnCh4.Text = ((_output & sPtn) != 0) ? "" : "";
                sPtn = 0x0010;
                btnCh5.Text = ((_output & sPtn) != 0) ? "" : "";
                sPtn = 0x0020;
                btnCh6.Text = ((_output & sPtn) != 0) ? "" : "";
                sPtn = 0x0040;
                btnCh7.Text = ((_output & sPtn) != 0) ? "" : "";
                sPtn = 0x0080;
                btnCh8.Text = ((_output & sPtn) != 0) ? "" : "";
            }
            else
            {
                vfnDllError("SS232CRLSW_read_output_data", iRet);
            }

        }
        //--------------------------------------------------------------------------------
        //[֐]ݒt@C̓ǂݍ
        //[]ݒt@Cp[^ǂݍ݂܂B
        //      ǂݍݎs̎͋Kl܂B
        //[]Ȃ
        //[ߒl]Ȃ
        //--------------------------------------------------------------------------------
        private void vfnReadIniFile()
        {
            StringBuilder buf = new StringBuilder();
            buf.Capacity = 32;
            GetPrivateProfileString("DEVICE", "COM", DEFAULT_COM, buf, 16, INI_FILE);   //ݒt@Cǂݍ
            _com = buf.ToString();
            GetPrivateProfileString("DEVICE", "ID", DEFAULT_ID.ToString(), buf, 16, INI_FILE);   //ݒt@Cǂݍ
            if (!byte.TryParse(buf.ToString(), out _id)) _id = DEFAULT_ID;
            GetPrivateProfileString("SETTING", "BAUDRATE", DEFAULT_BAUDRATE.ToString(), buf, 16, INI_FILE);   //ݒt@Cǂݍ
            if (!uint.TryParse(buf.ToString(), out _baudrate)) _baudrate = DEFAULT_BAUDRATE;
            GetPrivateProfileString("SETTING", "BYTE_SIZE", DEFAULT_BYTE_SIZE.ToString(), buf, 16, INI_FILE);   //ݒt@Cǂݍ
            if (!byte.TryParse(buf.ToString(), out _byte_size)) _byte_size = DEFAULT_BYTE_SIZE;
            GetPrivateProfileString("SETTING", "PARITY", DEFAULT_PARITY.ToString(), buf, 16, INI_FILE);   //ݒt@Cǂݍ
            if (!byte.TryParse(buf.ToString(), out _parity)) _parity = DEFAULT_PARITY;
            GetPrivateProfileString("SETTING", "STOP_BIT", DEFAULT_STOPBIT.ToString(), buf, 16, INI_FILE);   //ݒt@Cǂݍ
            if (!byte.TryParse(buf.ToString(), out _stop_bit)) _stop_bit = DEFAULT_STOPBIT;
        }
        //--------------------------------------------------------------------------------
        //[֐]ݒt@C̏
        //[]ݒt@CɃp[^݂܂B
        //[]Ȃ
        //[ߒl]Ȃ
        //--------------------------------------------------------------------------------
        private void vfnWriteIniFile()
        {
            WritePrivateProfileString("DEVICE", "COM", _com, INI_FILE);   //ݒt@Cɏ
            WritePrivateProfileString("DEVICE", "ID", _id.ToString(), INI_FILE);   //ݒt@Cɏ
            WritePrivateProfileString("SETTING", "BAUDRATE", _baudrate.ToString(), INI_FILE);   //ݒt@Cɏ
            WritePrivateProfileString("SETTING", "BYTE_SIZE", _byte_size.ToString(), INI_FILE);   //ݒt@Cɏ
            WritePrivateProfileString("SETTING", "PARITY", _parity.ToString(), INI_FILE);   //ݒt@Cɏ
            WritePrivateProfileString("SETTING", "STOP_BIT", _stop_bit.ToString(), INI_FILE);   //ݒt@Cɏ
        }
        //--------------------------------------------------------------------------------
        //[֐]p[^̏ԂRg[ɔf
        //[]p[^̏ԂΉRg[ɔf
        //[]Ȃ
        //[ߒl]Ȃ
        //--------------------------------------------------------------------------------
        private void vfnValueToControl()
        {
            cboCom.Text = _com;
            txtId.Text = _id.ToString("X2");
            cboSpeed.Text = _baudrate.ToString();
            switch (_byte_size)
            {
                case 8:
                    rdoBits8.Checked = true;
                    rdoBits7.Checked = false;
                    break;
                case 7:
                    rdoBits8.Checked = false;
                    rdoBits7.Checked = true;
                    break;
                default:
                    _byte_size = DEFAULT_BYTE_SIZE;
                    break;
            }
            switch (_parity)
            {
                case (byte)SS232CRLSW.PARITY.None:
                    rdoParityNone.Checked = true;
                    rdoParityOdd.Checked = false;
                    rdoParityEven.Checked = false;
                    break;
                case (byte)SS232CRLSW.PARITY.Odd:
                    rdoParityNone.Checked = false;
                    rdoParityOdd.Checked = true;
                    rdoParityEven.Checked = false;
                    break;
                case (int)SS232CRLSW.PARITY.Even:
                    rdoParityNone.Checked = false;
                    rdoParityOdd.Checked = false;
                    rdoParityEven.Checked = true;
                    break;
                default:
                    _parity = (byte)SS232CRLSW.PARITY.None;
                    break;
            }
            switch (_stop_bit)
            {
                case (byte)SS232CRLSW.STOPBIT.Bit1:
                    rdoStop1.Checked = true;
                    rdoStop2.Checked = false;
                    break;
                case (byte)SS232CRLSW.STOPBIT.Bit2:
                    rdoStop1.Checked = false;
                    rdoStop2.Checked = true;
                    break;
                default:
                    _stop_bit = (byte)SS232CRLSW.STOPBIT.Bit1;
                    break;
            }
        }
        //--------------------------------------------------------------------------------
        //[֐]Rg[̏Ԃp[^ɔf
        //[]Rg[̏ԂΉp[^ɔf܂B
        //[]Ȃ
        //[ߒl]Ȃ
        //--------------------------------------------------------------------------------
        private void vfnControlToValue()
        {
            _com = (string)cboCom.SelectedItem;
            _id = Convert.ToByte(txtId.Text, 16);
            _baudrate = uint.Parse((string)cboSpeed.SelectedItem);
        }
        //--------------------------------------------------------------------------------
        //[֐]Rg[͊mF
        //[]ID̓͏Ԃ̊mFs܂
        //[]Ȃ
        //[ߒl]true:,false:ُ
        //--------------------------------------------------------------------------------
        private bool bfnCheckControl()
        {
            try
            {
                byte b = Convert.ToByte(txtId.Text, 16);
            }
            catch
            {
                MessageBox.Show("ID̒lsłB\r\n00`FF", "̓G[", MessageBoxButtons.OK);
                return false;
            }
            return true;
        }
        //--------------------------------------------------------------------------------
        //[֐]DLLG[\
        //[]DLL̃G[\܂
        //[]txt  G[eLXg
        //           G[R[h
        //[ߒl]Ȃ
        //--------------------------------------------------------------------------------
        private void vfnDllError(string txt, int code)
        {
            string err;

            switch (code)
            {
                case SS232CRLSW.RET_ERR_OPEN: err = "I[vG["; break;
                case SS232CRLSW.RET_ERR_SEND: err = "MG["; break;
                case SS232CRLSW.RET_ERR_READ: err = "MG["; break;
                case SS232CRLSW.RET_ERR_SET_COM_STATE: err = "ʐMݒG["; break;
                case SS232CRLSW.RET_ERR_TIMEOUT: err = "^CAEgG["; break;
                case SS232CRLSW.RET_ERR_NO_DELIMITER: err = "f~^MȂG["; break;
                case SS232CRLSW.RET_ERR_BAUDRATE: err = "ʐMxݒG["; break;
                case SS232CRLSW.RET_ERR_BYTE_SIZE: err = "oCgݒG["; break;
                case SS232CRLSW.RET_ERR_PARITY: err = "peBݒG["; break;
                case SS232CRLSW.RET_ERR_STOP_BITS: err = "XgbvrbgݒG["; break;
                case SS232CRLSW.RET_ERR_RCV_FORMAT: err = "tH[}bgG["; break;
                default: err = ""; break;
            }
            MessageBox.Show(txt + "\r\n" + err, "Dll call error", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
    }
}